/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "functionbase.h"
#include "functions.h"



FunctionBase::FunctionBase()
{
	follow_symlinks = true;
	template_index  = size_t(-1);
	need_ssl		= false;

	fun.user_id    = -1;
	fun.group_id   = -1;
	fun.privileges = 07555;
	fun.parent_id  = -1;
	fun.id         = -1;
	fun.type       = Item::file;
}



void FunctionBase::SetConfig(Config * pconfig)
{
	config = pconfig;
}


void FunctionBase::SetCur(Cur * pcur)
{
	cur = pcur;
}



void FunctionBase::SetDb(Db * pdb)
{
	db = pdb;
}


void FunctionBase::SetSystem(System * psystem)
{
	system = psystem;
}


void FunctionBase::SetFunctions(Functions * pfunctions)
{
	functions = pfunctions;
}


void FunctionBase::SetTemplates(Templates * ptemplates)
{
	templates = ptemplates;
}


void FunctionBase::SetSynchro(Synchro * psynchro)
{
	synchro = psynchro;
}


void FunctionBase::SetSessionManager(SessionManager * pmanager)
{
	session_manager = pmanager;
}


void FunctionBase::Init()
{
	// this method is called only once at the beginning
	// when winix starts
}


bool FunctionBase::HasAccess()
{
	// true by default
	return true;
}



void FunctionBase::MakePost()
{
	// do nothing by default
}


void FunctionBase::MakeGet()
{
	// do nothing by default
}




