/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2011-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_functions_meta
#define headerfile_winix_functions_meta

#include "functionbase.h"
#include "space/spaceparser.h"


namespace Fun
{


class Meta : public FunctionBase
{
public:

	Meta();

	bool HasAccess();
	void MakePost();

	bool EditAdminMeta(long item_id, const std::wstring & meta_str, bool use_ses_log = false);
	bool EditMeta(long item_id, const std::wstring & meta_str, bool use_ses_log = false);

private:

	PT::SpaceParser conf_parser;
	PT::Space space;

	bool Parse(const std::wstring & meta_str);
	void ChangeAdminMeta();
	void ChangeMeta();

};


} // namespace

#endif
