/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010-2012, Tomasz Sowa
 * All rights reserved.
 * 
 */

#ifndef headerfile_winix_templates_misc
#define headerfile_winix_templates_misc


#include <vector>
#include <string>
#include "localefilter.h"
#include "ezc.h"
#include "htmltextstream.h"

struct User;


namespace TemplatesFunctions
{


typedef Ezc::Functions<HtmlTextStream> EzcFun;
typedef Ezc::Generator<HtmlTextStream> EzcGen;
typedef Ezc::FunInfo<HtmlTextStream>   Info;

template<class RawType>
HtmlTextStream::RawText<RawType> R(const RawType & par)
{
	return HtmlTextStream::RawText<RawType>(par);
}


void HtmlEscapeFormTxt(HtmlTextStream & out, const std::wstring & in);

void print_hour_min(Info & i,  time_t time);
void print_date_nice(Info & i, const PT::Date & date);


/*
	print a user name -- it is trying to use 'display_name' from user's admin env
	if it not find it or if the 'display_name' is all white (consists of all white characters)
	then the login name is printed
*/
void print_user_name(Info & i, User & user);



/*
	puser can be null -- in such a case guest_name is used
	if guest_name is empty then 'display_guest_name' from locales is printed
*/
void print_user_name(Info & i, User * puser, const std::wstring & guest_name);




} // namespace TemplatesFunctions

#endif

